// SATIrE wrapper header file for <rose.h> to suppress warnings related to
// redefinition of autoconf macros.

#ifndef SATIRE_ROSE_H
#define SATIRE_ROSE_H

// FIXME: Workaround a strange bug with ROSE 0.9.5
#include <cassert>
#define ROSE_ASSERT assert

// Undefine existing definitions.
#undef PACKAGE
#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#undef VERSION

// Include ROSE's definitions.
#include <rose.h>
// A header included by <rose.h> #defines TRUE and FALSE macros; these are
// unnecessary, and they also conflict with macros defined by PAG. Undefine
// them here to avoid redefinition warnings.
#undef TRUE
#undef FALSE

// GB (2008-08-21): We will undefine ROSE's definitions below. However,
// rather than throwing them away, let's keep copies around, because they
// might come in handy some time.
#define ROSE_PACKAGE PACKAGE
#define ROSE_PACKAGE_BUGREPORT PACKAGE_BUGREPORT
#define ROSE_PACKAGE_NAME PACKAGE_NAME
#define ROSE_PACKAGE_STRING PACKAGE_STRING
#define ROSE_PACKAGE_TARNAME PACKAGE_TARNAME
#define ROSE_PACKAGE_VERSION PACKAGE_VERSION
#define ROSE_VERSION VERSION

// Undefine ROSE's definitions.
#undef PACKAGE
#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#undef VERSION

// Finally, redefine our definitions.
// ... which is actually impossible:
// http://www.redhat.com/docs/manuals/enterprise/RHEL-4-Manual/cpp/undefining-and-redefining-macros.html
#define PACKAGE "satire@"
#define PACKAGE_BUGREPORT "schordan@technikum-wien.at or adrian@llnl.gov"
#define PACKAGE_NAME "SATIrE"
#define PACKAGE_STRING "SATIrE 0.9.0"
#define PACKAGE_TARNAME "satire"
#define PACKAGE_VERSION "0.9.0"
#define VERSION "0.9.0"

// Therefore...
#define SATIRE_PACKAGE "satire"
#define SATIRE_PACKAGE_BUGREPORT "schordan@technikum-wien.at or adrian@llnl.gov"
#define SATIRE_PACKAGE_NAME "SATIrE"
#define SATIRE_PACKAGE_STRING "SATIrE 0.9.0"
#define SATIRE_PACKAGE_TARNAME "satire"
#define SATIRE_PACKAGE_VERSION "0.9.0"
#define SATIRE_VERSION "0.9.0"

#endif
